SystemOrganization addCategory: #'TP2-Parte4'!

Object subclass: #ClaseAbuela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

ClaseAbuela subclass: #ClasePadre
	instanceVariableNames: 'variableDeComposicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!ClasePadre methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoParaRedefinicion
		^self variableDeComposicion metodoParaRedefinicion! !

!ClasePadre methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoSencillo
		^self variableDeComposicion metodoSencillo! !

!ClasePadre methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
variableDeComposicion
		^variableDeComposicion! !

!ClasePadre methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
variableDeComposicion: unObjeto
		variableDeComposicion := unObjeto! !

ClaseAbuela subclass: #ClasePadreConMetodosRedefinidos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

ClasePadreConMetodosRedefinidos subclass: #ClaseHija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!ClaseHija1 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoParaRedefinicion
	^super metodoParaRedefinicion * 2! !

!ClaseHija1 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoSencillo
	^1! !

ClasePadreConMetodosRedefinidos subclass: #ClaseHija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!ClasePadreConMetodosRedefinidos methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoParaRedefinicion
	^1! !

!ClasePadreConMetodosRedefinidos methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:12'!
metodoSencillo
		^self variableDeComposicion metodoSencillo! !

Object subclass: #HerenciaAComposicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 07:06'!
agregarVariableYCambiarLosSuperA: estaClase ante: unosMetodos.

	estaClase addInstVarNamed: 'variableDeComposicion'. "Nombre medio largo y poco expresivo para que sea poco probable que ya exista"
	estaClase compile:
		'variableDeComposicion: unObjeto
		variableDeComposicion := unObjeto'.
	estaClase compile:
		'variableDeComposicion
		^variableDeComposicion'.
		
	unosMetodos do: [:unMetodo | estaClase compile:
		unMetodo selector asString,'
		^self variableDeComposicion ',unMetodo selector asString ].
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 06:35'!
hacerQueLasSubclasesDe: estaClase heredenDe: estePadre
	
	|metodos|
	metodos := estaClase subclasses gather: [:unaSubclase| unaSubclase methods].
	
	estaClase subclasses do: [:unaSubclase |unaSubclase superclass: estePadre. estePadre addSubclass: unaSubclase. estaClase removeSubclass: unaSubclase].
	
	self agregarVariableYCambiarLosSuperA: estaClase ante: metodos.! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 01:37'!
obtenerNuevoPadreParaLasSubclasesDe: estaClase
	|nombre|
	nombre := estaClase name.
	
	nombre := nombre,'ConMetodosRedefinidos'.
	
	^(estaClase superclass subclass: nombre asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4')
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 06:30'!
pasarHerenciaAComposicionEn: estaClase
	|nuevoPadre|
	(self tienenMetodosRedefinidosLasSubclasesDe: estaClase)
		ifTrue:
			[	
			nuevoPadre := self obtenerNuevoPadreParaLasSubclasesDe: estaClase.
			self pasarMetodosRedefinidosDeSubclasesDe: estaClase a: nuevoPadre.]
		ifFalse:
			[nuevoPadre := estaClase superclass].
		self hacerQueLasSubclasesDe: estaClase heredenDe: nuevoPadre.
		
		
		
		
		
		
		
	! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 02:44'!
pasarMetodosRedefinidosDeSubclasesDe: estaClase a: nuevoPadre
	|metodos|
	metodos := estaClase methods select: [:metodo | metodo isOverriden].	
	metodos do: [:metodo | nuevoPadre compile: metodo].! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 03:35'!
subirUnNivelDeHerenciaDeSubclasesDe: estaClase
	
	self hacerQueLasSubclasesDe: estaClase heredenDe: estaClase superclass.
! !

!HerenciaAComposicion class methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 02:28'!
tienenMetodosRedefinidosLasSubclasesDe: estaClase
	
	^estaClase subclasses anySatisfy: [:unaSubclase | unaSubclase methods anySatisfy: [:m1 | m1 isOverride]].
		! !

TestCase subclass: #TestTP2Parte4
	instanceVariableNames: 'claseAbuela clasePadre claseHija1 claseHija2 metodos clasePadreNueva objetitoDePrueba'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'!

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 07:50'!
borrarMetodosDeLasClases.

	"Esto es por si quedaron creadas desde antes"
	metodos := claseAbuela methods.
	metodos do: [:metodo | claseAbuela removeSelector: metodo selector].
	metodos := clasePadre methods.
	metodos do: [:metodo | clasePadre removeSelector: metodo selector].
	metodos := claseHija1  methods.
	metodos do: [:metodo | claseHija1 removeSelector: metodo selector].
	metodos := claseHija2 methods.
	metodos do: [:metodo | claseHija2 removeSelector: metodo selector].
	metodos := clasePadreNueva methods.
	metodos do: [:metodo | clasePadreNueva removeSelector: metodo selector].

	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:06'!
borrarReferenciasAClasesExistentes.
		
	ClaseAbuela removeFromSystem.
	ClasePadre removeFromSystem.
	ClaseHija1 removeFromSystem.
	ClaseHija2 removeFromSystem.
	ClasePadreConMetodosRedefinidos removeFromSystem.
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 07:51'!
crearLasClasesDeCeroYAgregarMetodos.
	
	self inicializarVariables.	clasePadre compile:
	'metodoParaRedefinicion
	^1'.
	
	claseHija1 compile:
	'metodoParaRedefinicion
	^super metodoParaRedefinicion * 2'.
	
	claseHija1 compile:
	'metodoSencillo
	^1'.
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 07:49'!
inicializarVariables.
	
	claseAbuela := Object subclass: #ClaseAbuela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadre := claseAbuela subclass: #ClasePadre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	claseHija1 := clasePadre subclass: #ClaseHija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija2 := clasePadre subclass: #ClaseHija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadreNueva := claseAbuela subclass: #ClasePadreConMetodosRedefinidos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:16'!
setUp
	
	"self inicializarVariables.
	
	self borrarMetodosDeLasClases."
	
	self borrarReferenciasAClasesExistentes.
	
	self crearLasClasesDeCeroYAgregarMetodos.
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:05'!
testCrearNuevoPadreParaUnasSubclases
	"Este test es la previa para cuando se redefinen mtodos"
	
	"unaClase := Object subclass: #UnaClase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija1 := unaClase subclass: #Hija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija2 := unaClase subclass: #Hija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'."
	
	clasePadreNueva := HerenciaAComposicion obtenerNuevoPadreParaLasSubclasesDe: clasePadre.
	
	self assert: clasePadreNueva name = (clasePadre name, 'ConMetodosRedefinidos').! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 06:16'!
testDetectarSiExistenMetodosRedefinidos
	
	"clasePadre := Object subclass: #PadreConMetodosQueSeRedefinen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	claseHija1 := clasePadre subclass: #HijaQueRedefineMetodos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadre compile:
	'metodoParaRedefinicion
	^1'.
	
	claseHija1 compile:
	'metodoParaRedefinicion
	^super metodoParaRedefinicion * 2'."
	
	
	self assert: (HerenciaAComposicion tienenMetodosRedefinidosLasSubclasesDe: clasePadre).! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:04'!
testPasarHerenciaAComposicionYProbarMetodoDesdeLaExClaseAbstracta
		
	HerenciaAComposicion pasarHerenciaAComposicionEn: clasePadre.
	
	"La clase hija 1 ya no es hija de clase padre, pero ahora la usamos para componer"
	objetitoDePrueba := clasePadre new.
	objetitoDePrueba variableDeComposicion: claseHija1 new.
	
	"Ahora debera entender el mensaje, debido a que internamete se lo delega a la composicin"
	self assert: objetitoDePrueba metodoSencillo = 1.
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:04'!
testPasarHerenciaAComposicionYProbarMetodoRedefinido
	"claseAbuela := Object subclass: #ClaseAbuela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadre := claseAbuela subclass: #PadreConMetodoARedefinir
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	claseHija1 := clasePadre subclass: #ClaseHijaQueRedefineMetodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadre compile:
	'metodoParaRedefinicion
	^1'.
	
	claseHija1 compile:
	'metodoParaRedefinicion
	^super metodoParaRedefinicion * 2'."
	
	HerenciaAComposicion pasarHerenciaAComposicionEn: clasePadre.
	
	objetitoDePrueba := claseHija1 new.
	
	"metodoParaRedefinicion usa el mtodo de la superclase. Si anda, es porque se pas bien el mtodo a la nueva superclase"
	self assert: claseHija1 superclass ~= clasePadre superclass &
				(claseHija1 superclass ~= clasePadre ) &
				(objetitoDePrueba metodoParaRedefinicion = 2).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 06:19'!
testSubirNivelDeHerenciaDeSubclases
	|subclases|
	
	"clasePadre := claseAbuela subclass: #ClasePadre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	claseHija1 := clasePadre subclass: #ClaseHija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija2 := clasePadre subclass: #ClaseHija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'."
	
	subclases := clasePadre subclasses.
	
	HerenciaAComposicion subirUnNivelDeHerenciaDeSubclasesDe: clasePadre.
	
	self assert: (subclases allSatisfy: [:unaSubclase | unaSubclase superclass = clasePadre superclass]).
	
! !

!TestTP2Parte4 methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 5/3/2013 08:05'!
testSubirNivelDeHerenciaDeSubclasesYProbarMetodoSencillo
	
	"claseAbuela := Object subclass: #Abuela
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	clasePadre := claseAbuela subclass: #Padre
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
			
	claseHija1 := clasePadre subclass: #Hija1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija2 := clasePadre subclass: #Hija2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte4'.
	
	claseHija1 compile:
	'metodoSencillo
	^1'."
	
	HerenciaAComposicion subirUnNivelDeHerenciaDeSubclasesDe: clasePadre.
	
	objetitoDePrueba := claseHija1 new.
	
	self assert: claseHija1 superclass = clasePadre superclass & (objetitoDePrueba metodoSencillo = 1).
	
! !
